package de.doubleslash.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.util.PortalUtil;

import de.doubleslash.service.ClpSerializer;
import de.doubleslash.service.DemoLocalServiceUtil;

import java.io.Serializable;

import java.lang.reflect.Method;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;


public class DemoClp extends BaseModelImpl<Demo> implements Demo {
    private long _demoId;
    private long _creatorGroupId;
    private long _creatorCompanyId;
    private long _creatorUserId;
    private String _creatorUserUuid;
    private String _creatorUserName;
    private Date _createDate;
    private Date _modifiedDate;
    private String _text;
    private BaseModel<?> _demoRemoteModel;
    private Class<?> _clpSerializerClass = de.doubleslash.service.ClpSerializer.class;

    public DemoClp() {
    }

    @Override
    public Class<?> getModelClass() {
        return Demo.class;
    }

    @Override
    public String getModelClassName() {
        return Demo.class.getName();
    }

    @Override
    public long getPrimaryKey() {
        return _demoId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setDemoId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _demoId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("demoId", getDemoId());
        attributes.put("creatorGroupId", getCreatorGroupId());
        attributes.put("creatorCompanyId", getCreatorCompanyId());
        attributes.put("creatorUserId", getCreatorUserId());
        attributes.put("creatorUserName", getCreatorUserName());
        attributes.put("createDate", getCreateDate());
        attributes.put("modifiedDate", getModifiedDate());
        attributes.put("text", getText());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long demoId = (Long) attributes.get("demoId");

        if (demoId != null) {
            setDemoId(demoId);
        }

        Long creatorGroupId = (Long) attributes.get("creatorGroupId");

        if (creatorGroupId != null) {
            setCreatorGroupId(creatorGroupId);
        }

        Long creatorCompanyId = (Long) attributes.get("creatorCompanyId");

        if (creatorCompanyId != null) {
            setCreatorCompanyId(creatorCompanyId);
        }

        Long creatorUserId = (Long) attributes.get("creatorUserId");

        if (creatorUserId != null) {
            setCreatorUserId(creatorUserId);
        }

        String creatorUserName = (String) attributes.get("creatorUserName");

        if (creatorUserName != null) {
            setCreatorUserName(creatorUserName);
        }

        Date createDate = (Date) attributes.get("createDate");

        if (createDate != null) {
            setCreateDate(createDate);
        }

        Date modifiedDate = (Date) attributes.get("modifiedDate");

        if (modifiedDate != null) {
            setModifiedDate(modifiedDate);
        }

        String text = (String) attributes.get("text");

        if (text != null) {
            setText(text);
        }
    }

    @Override
    public long getDemoId() {
        return _demoId;
    }

    @Override
    public void setDemoId(long demoId) {
        _demoId = demoId;

        if (_demoRemoteModel != null) {
            try {
                Class<?> clazz = _demoRemoteModel.getClass();

                Method method = clazz.getMethod("setDemoId", long.class);

                method.invoke(_demoRemoteModel, demoId);
            } catch (Exception e) {
                throw new UnsupportedOperationException(e);
            }
        }
    }

    @Override
    public long getCreatorGroupId() {
        return _creatorGroupId;
    }

    @Override
    public void setCreatorGroupId(long creatorGroupId) {
        _creatorGroupId = creatorGroupId;

        if (_demoRemoteModel != null) {
            try {
                Class<?> clazz = _demoRemoteModel.getClass();

                Method method = clazz.getMethod("setCreatorGroupId", long.class);

                method.invoke(_demoRemoteModel, creatorGroupId);
            } catch (Exception e) {
                throw new UnsupportedOperationException(e);
            }
        }
    }

    @Override
    public long getCreatorCompanyId() {
        return _creatorCompanyId;
    }

    @Override
    public void setCreatorCompanyId(long creatorCompanyId) {
        _creatorCompanyId = creatorCompanyId;

        if (_demoRemoteModel != null) {
            try {
                Class<?> clazz = _demoRemoteModel.getClass();

                Method method = clazz.getMethod("setCreatorCompanyId",
                        long.class);

                method.invoke(_demoRemoteModel, creatorCompanyId);
            } catch (Exception e) {
                throw new UnsupportedOperationException(e);
            }
        }
    }

    @Override
    public long getCreatorUserId() {
        return _creatorUserId;
    }

    @Override
    public void setCreatorUserId(long creatorUserId) {
        _creatorUserId = creatorUserId;

        if (_demoRemoteModel != null) {
            try {
                Class<?> clazz = _demoRemoteModel.getClass();

                Method method = clazz.getMethod("setCreatorUserId", long.class);

                method.invoke(_demoRemoteModel, creatorUserId);
            } catch (Exception e) {
                throw new UnsupportedOperationException(e);
            }
        }
    }

    @Override
    public String getCreatorUserUuid() throws SystemException {
        return PortalUtil.getUserValue(getCreatorUserId(), "uuid",
            _creatorUserUuid);
    }

    @Override
    public void setCreatorUserUuid(String creatorUserUuid) {
        _creatorUserUuid = creatorUserUuid;
    }

    @Override
    public String getCreatorUserName() {
        return _creatorUserName;
    }

    @Override
    public void setCreatorUserName(String creatorUserName) {
        _creatorUserName = creatorUserName;

        if (_demoRemoteModel != null) {
            try {
                Class<?> clazz = _demoRemoteModel.getClass();

                Method method = clazz.getMethod("setCreatorUserName",
                        String.class);

                method.invoke(_demoRemoteModel, creatorUserName);
            } catch (Exception e) {
                throw new UnsupportedOperationException(e);
            }
        }
    }

    @Override
    public Date getCreateDate() {
        return _createDate;
    }

    @Override
    public void setCreateDate(Date createDate) {
        _createDate = createDate;

        if (_demoRemoteModel != null) {
            try {
                Class<?> clazz = _demoRemoteModel.getClass();

                Method method = clazz.getMethod("setCreateDate", Date.class);

                method.invoke(_demoRemoteModel, createDate);
            } catch (Exception e) {
                throw new UnsupportedOperationException(e);
            }
        }
    }

    @Override
    public Date getModifiedDate() {
        return _modifiedDate;
    }

    @Override
    public void setModifiedDate(Date modifiedDate) {
        _modifiedDate = modifiedDate;

        if (_demoRemoteModel != null) {
            try {
                Class<?> clazz = _demoRemoteModel.getClass();

                Method method = clazz.getMethod("setModifiedDate", Date.class);

                method.invoke(_demoRemoteModel, modifiedDate);
            } catch (Exception e) {
                throw new UnsupportedOperationException(e);
            }
        }
    }

    @Override
    public String getText() {
        return _text;
    }

    @Override
    public void setText(String text) {
        _text = text;

        if (_demoRemoteModel != null) {
            try {
                Class<?> clazz = _demoRemoteModel.getClass();

                Method method = clazz.getMethod("setText", String.class);

                method.invoke(_demoRemoteModel, text);
            } catch (Exception e) {
                throw new UnsupportedOperationException(e);
            }
        }
    }

    public BaseModel<?> getDemoRemoteModel() {
        return _demoRemoteModel;
    }

    public void setDemoRemoteModel(BaseModel<?> demoRemoteModel) {
        _demoRemoteModel = demoRemoteModel;
    }

    public Object invokeOnRemoteModel(String methodName,
        Class<?>[] parameterTypes, Object[] parameterValues)
        throws Exception {
        Object[] remoteParameterValues = new Object[parameterValues.length];

        for (int i = 0; i < parameterValues.length; i++) {
            if (parameterValues[i] != null) {
                remoteParameterValues[i] = ClpSerializer.translateInput(parameterValues[i]);
            }
        }

        Class<?> remoteModelClass = _demoRemoteModel.getClass();

        ClassLoader remoteModelClassLoader = remoteModelClass.getClassLoader();

        Class<?>[] remoteParameterTypes = new Class[parameterTypes.length];

        for (int i = 0; i < parameterTypes.length; i++) {
            if (parameterTypes[i].isPrimitive()) {
                remoteParameterTypes[i] = parameterTypes[i];
            } else {
                String parameterTypeName = parameterTypes[i].getName();

                remoteParameterTypes[i] = remoteModelClassLoader.loadClass(parameterTypeName);
            }
        }

        Method method = remoteModelClass.getMethod(methodName,
                remoteParameterTypes);

        Object returnValue = method.invoke(_demoRemoteModel,
                remoteParameterValues);

        if (returnValue != null) {
            returnValue = ClpSerializer.translateOutput(returnValue);
        }

        return returnValue;
    }

    @Override
    public void persist() throws SystemException {
        if (this.isNew()) {
            DemoLocalServiceUtil.addDemo(this);
        } else {
            DemoLocalServiceUtil.updateDemo(this);
        }
    }

    @Override
    public Demo toEscapedModel() {
        return (Demo) ProxyUtil.newProxyInstance(Demo.class.getClassLoader(),
            new Class[] { Demo.class }, new AutoEscapeBeanHandler(this));
    }

    @Override
    public Object clone() {
        DemoClp clone = new DemoClp();

        clone.setDemoId(getDemoId());
        clone.setCreatorGroupId(getCreatorGroupId());
        clone.setCreatorCompanyId(getCreatorCompanyId());
        clone.setCreatorUserId(getCreatorUserId());
        clone.setCreatorUserName(getCreatorUserName());
        clone.setCreateDate(getCreateDate());
        clone.setModifiedDate(getModifiedDate());
        clone.setText(getText());

        return clone;
    }

    @Override
    public int compareTo(Demo demo) {
        int value = 0;

        if (getDemoId() < demo.getDemoId()) {
            value = -1;
        } else if (getDemoId() > demo.getDemoId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof DemoClp)) {
            return false;
        }

        DemoClp demo = (DemoClp) obj;

        long primaryKey = demo.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    public Class<?> getClpSerializerClass() {
        return _clpSerializerClass;
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(17);

        sb.append("{demoId=");
        sb.append(getDemoId());
        sb.append(", creatorGroupId=");
        sb.append(getCreatorGroupId());
        sb.append(", creatorCompanyId=");
        sb.append(getCreatorCompanyId());
        sb.append(", creatorUserId=");
        sb.append(getCreatorUserId());
        sb.append(", creatorUserName=");
        sb.append(getCreatorUserName());
        sb.append(", createDate=");
        sb.append(getCreateDate());
        sb.append(", modifiedDate=");
        sb.append(getModifiedDate());
        sb.append(", text=");
        sb.append(getText());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(28);

        sb.append("<model><model-name>");
        sb.append("de.doubleslash.model.Demo");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>demoId</column-name><column-value><![CDATA[");
        sb.append(getDemoId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorGroupId</column-name><column-value><![CDATA[");
        sb.append(getCreatorGroupId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorCompanyId</column-name><column-value><![CDATA[");
        sb.append(getCreatorCompanyId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorUserId</column-name><column-value><![CDATA[");
        sb.append(getCreatorUserId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorUserName</column-name><column-value><![CDATA[");
        sb.append(getCreatorUserName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>createDate</column-name><column-value><![CDATA[");
        sb.append(getCreateDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
        sb.append(getModifiedDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>text</column-name><column-value><![CDATA[");
        sb.append(getText());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
