package de.doubleslash.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Demo service. Represents a row in the &quot;Demo_Demo&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link de.doubleslash.model.impl.DemoModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link de.doubleslash.model.impl.DemoImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see Demo
 * @see de.doubleslash.model.impl.DemoImpl
 * @see de.doubleslash.model.impl.DemoModelImpl
 * @generated
 */
public interface DemoModel extends BaseModel<Demo> {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this interface directly. All methods that expect a demo model instance should use the {@link Demo} interface instead.
     */

    /**
     * Returns the primary key of this demo.
     *
     * @return the primary key of this demo
     */
    public long getPrimaryKey();

    /**
     * Sets the primary key of this demo.
     *
     * @param primaryKey the primary key of this demo
     */
    public void setPrimaryKey(long primaryKey);

    /**
     * Returns the demo ID of this demo.
     *
     * @return the demo ID of this demo
     */
    public long getDemoId();

    /**
     * Sets the demo ID of this demo.
     *
     * @param demoId the demo ID of this demo
     */
    public void setDemoId(long demoId);

    /**
     * Returns the creator group ID of this demo.
     *
     * @return the creator group ID of this demo
     */
    public long getCreatorGroupId();

    /**
     * Sets the creator group ID of this demo.
     *
     * @param creatorGroupId the creator group ID of this demo
     */
    public void setCreatorGroupId(long creatorGroupId);

    /**
     * Returns the creator company ID of this demo.
     *
     * @return the creator company ID of this demo
     */
    public long getCreatorCompanyId();

    /**
     * Sets the creator company ID of this demo.
     *
     * @param creatorCompanyId the creator company ID of this demo
     */
    public void setCreatorCompanyId(long creatorCompanyId);

    /**
     * Returns the creator user ID of this demo.
     *
     * @return the creator user ID of this demo
     */
    public long getCreatorUserId();

    /**
     * Sets the creator user ID of this demo.
     *
     * @param creatorUserId the creator user ID of this demo
     */
    public void setCreatorUserId(long creatorUserId);

    /**
     * Returns the creator user uuid of this demo.
     *
     * @return the creator user uuid of this demo
     * @throws SystemException if a system exception occurred
     */
    public String getCreatorUserUuid() throws SystemException;

    /**
     * Sets the creator user uuid of this demo.
     *
     * @param creatorUserUuid the creator user uuid of this demo
     */
    public void setCreatorUserUuid(String creatorUserUuid);

    /**
     * Returns the creator user name of this demo.
     *
     * @return the creator user name of this demo
     */
    @AutoEscape
    public String getCreatorUserName();

    /**
     * Sets the creator user name of this demo.
     *
     * @param creatorUserName the creator user name of this demo
     */
    public void setCreatorUserName(String creatorUserName);

    /**
     * Returns the create date of this demo.
     *
     * @return the create date of this demo
     */
    public Date getCreateDate();

    /**
     * Sets the create date of this demo.
     *
     * @param createDate the create date of this demo
     */
    public void setCreateDate(Date createDate);

    /**
     * Returns the modified date of this demo.
     *
     * @return the modified date of this demo
     */
    public Date getModifiedDate();

    /**
     * Sets the modified date of this demo.
     *
     * @param modifiedDate the modified date of this demo
     */
    public void setModifiedDate(Date modifiedDate);

    /**
     * Returns the text of this demo.
     *
     * @return the text of this demo
     */
    @AutoEscape
    public String getText();

    /**
     * Sets the text of this demo.
     *
     * @param text the text of this demo
     */
    public void setText(String text);

    @Override
    public boolean isNew();

    @Override
    public void setNew(boolean n);

    @Override
    public boolean isCachedModel();

    @Override
    public void setCachedModel(boolean cachedModel);

    @Override
    public boolean isEscapedModel();

    @Override
    public Serializable getPrimaryKeyObj();

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj);

    @Override
    public ExpandoBridge getExpandoBridge();

    @Override
    public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

    @Override
    public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext);

    @Override
    public Object clone();

    @Override
    public int compareTo(Demo demo);

    @Override
    public int hashCode();

    @Override
    public CacheModel<Demo> toCacheModel();

    @Override
    public Demo toEscapedModel();

    @Override
    public Demo toUnescapedModel();

    @Override
    public String toString();

    @Override
    public String toXmlString();
}
