package de.doubleslash.model;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * This class is used by SOAP remote services, specifically {@link de.doubleslash.service.http.DemoServiceSoap}.
 *
 * @author Brian Wing Shun Chan
 * @see de.doubleslash.service.http.DemoServiceSoap
 * @generated
 */
public class DemoSoap implements Serializable {
    private long _demoId;
    private long _creatorGroupId;
    private long _creatorCompanyId;
    private long _creatorUserId;
    private String _creatorUserName;
    private Date _createDate;
    private Date _modifiedDate;
    private String _text;

    public DemoSoap() {
    }

    public static DemoSoap toSoapModel(Demo model) {
        DemoSoap soapModel = new DemoSoap();

        soapModel.setDemoId(model.getDemoId());
        soapModel.setCreatorGroupId(model.getCreatorGroupId());
        soapModel.setCreatorCompanyId(model.getCreatorCompanyId());
        soapModel.setCreatorUserId(model.getCreatorUserId());
        soapModel.setCreatorUserName(model.getCreatorUserName());
        soapModel.setCreateDate(model.getCreateDate());
        soapModel.setModifiedDate(model.getModifiedDate());
        soapModel.setText(model.getText());

        return soapModel;
    }

    public static DemoSoap[] toSoapModels(Demo[] models) {
        DemoSoap[] soapModels = new DemoSoap[models.length];

        for (int i = 0; i < models.length; i++) {
            soapModels[i] = toSoapModel(models[i]);
        }

        return soapModels;
    }

    public static DemoSoap[][] toSoapModels(Demo[][] models) {
        DemoSoap[][] soapModels = null;

        if (models.length > 0) {
            soapModels = new DemoSoap[models.length][models[0].length];
        } else {
            soapModels = new DemoSoap[0][0];
        }

        for (int i = 0; i < models.length; i++) {
            soapModels[i] = toSoapModels(models[i]);
        }

        return soapModels;
    }

    public static DemoSoap[] toSoapModels(List<Demo> models) {
        List<DemoSoap> soapModels = new ArrayList<DemoSoap>(models.size());

        for (Demo model : models) {
            soapModels.add(toSoapModel(model));
        }

        return soapModels.toArray(new DemoSoap[soapModels.size()]);
    }

    public long getPrimaryKey() {
        return _demoId;
    }

    public void setPrimaryKey(long pk) {
        setDemoId(pk);
    }

    public long getDemoId() {
        return _demoId;
    }

    public void setDemoId(long demoId) {
        _demoId = demoId;
    }

    public long getCreatorGroupId() {
        return _creatorGroupId;
    }

    public void setCreatorGroupId(long creatorGroupId) {
        _creatorGroupId = creatorGroupId;
    }

    public long getCreatorCompanyId() {
        return _creatorCompanyId;
    }

    public void setCreatorCompanyId(long creatorCompanyId) {
        _creatorCompanyId = creatorCompanyId;
    }

    public long getCreatorUserId() {
        return _creatorUserId;
    }

    public void setCreatorUserId(long creatorUserId) {
        _creatorUserId = creatorUserId;
    }

    public String getCreatorUserName() {
        return _creatorUserName;
    }

    public void setCreatorUserName(String creatorUserName) {
        _creatorUserName = creatorUserName;
    }

    public Date getCreateDate() {
        return _createDate;
    }

    public void setCreateDate(Date createDate) {
        _createDate = createDate;
    }

    public Date getModifiedDate() {
        return _modifiedDate;
    }

    public void setModifiedDate(Date modifiedDate) {
        _modifiedDate = modifiedDate;
    }

    public String getText() {
        return _text;
    }

    public void setText(String text) {
        _text = text;
    }
}
