package de.doubleslash.model;

import com.liferay.portal.kernel.util.Validator;
import com.liferay.portal.model.ModelWrapper;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * <p>
 * This class is a wrapper for {@link Demo}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see Demo
 * @generated
 */
public class DemoWrapper implements Demo, ModelWrapper<Demo> {
    private Demo _demo;

    public DemoWrapper(Demo demo) {
        _demo = demo;
    }

    @Override
    public Class<?> getModelClass() {
        return Demo.class;
    }

    @Override
    public String getModelClassName() {
        return Demo.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("demoId", getDemoId());
        attributes.put("creatorGroupId", getCreatorGroupId());
        attributes.put("creatorCompanyId", getCreatorCompanyId());
        attributes.put("creatorUserId", getCreatorUserId());
        attributes.put("creatorUserName", getCreatorUserName());
        attributes.put("createDate", getCreateDate());
        attributes.put("modifiedDate", getModifiedDate());
        attributes.put("text", getText());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long demoId = (Long) attributes.get("demoId");

        if (demoId != null) {
            setDemoId(demoId);
        }

        Long creatorGroupId = (Long) attributes.get("creatorGroupId");

        if (creatorGroupId != null) {
            setCreatorGroupId(creatorGroupId);
        }

        Long creatorCompanyId = (Long) attributes.get("creatorCompanyId");

        if (creatorCompanyId != null) {
            setCreatorCompanyId(creatorCompanyId);
        }

        Long creatorUserId = (Long) attributes.get("creatorUserId");

        if (creatorUserId != null) {
            setCreatorUserId(creatorUserId);
        }

        String creatorUserName = (String) attributes.get("creatorUserName");

        if (creatorUserName != null) {
            setCreatorUserName(creatorUserName);
        }

        Date createDate = (Date) attributes.get("createDate");

        if (createDate != null) {
            setCreateDate(createDate);
        }

        Date modifiedDate = (Date) attributes.get("modifiedDate");

        if (modifiedDate != null) {
            setModifiedDate(modifiedDate);
        }

        String text = (String) attributes.get("text");

        if (text != null) {
            setText(text);
        }
    }

    /**
    * Returns the primary key of this demo.
    *
    * @return the primary key of this demo
    */
    @Override
    public long getPrimaryKey() {
        return _demo.getPrimaryKey();
    }

    /**
    * Sets the primary key of this demo.
    *
    * @param primaryKey the primary key of this demo
    */
    @Override
    public void setPrimaryKey(long primaryKey) {
        _demo.setPrimaryKey(primaryKey);
    }

    /**
    * Returns the demo ID of this demo.
    *
    * @return the demo ID of this demo
    */
    @Override
    public long getDemoId() {
        return _demo.getDemoId();
    }

    /**
    * Sets the demo ID of this demo.
    *
    * @param demoId the demo ID of this demo
    */
    @Override
    public void setDemoId(long demoId) {
        _demo.setDemoId(demoId);
    }

    /**
    * Returns the creator group ID of this demo.
    *
    * @return the creator group ID of this demo
    */
    @Override
    public long getCreatorGroupId() {
        return _demo.getCreatorGroupId();
    }

    /**
    * Sets the creator group ID of this demo.
    *
    * @param creatorGroupId the creator group ID of this demo
    */
    @Override
    public void setCreatorGroupId(long creatorGroupId) {
        _demo.setCreatorGroupId(creatorGroupId);
    }

    /**
    * Returns the creator company ID of this demo.
    *
    * @return the creator company ID of this demo
    */
    @Override
    public long getCreatorCompanyId() {
        return _demo.getCreatorCompanyId();
    }

    /**
    * Sets the creator company ID of this demo.
    *
    * @param creatorCompanyId the creator company ID of this demo
    */
    @Override
    public void setCreatorCompanyId(long creatorCompanyId) {
        _demo.setCreatorCompanyId(creatorCompanyId);
    }

    /**
    * Returns the creator user ID of this demo.
    *
    * @return the creator user ID of this demo
    */
    @Override
    public long getCreatorUserId() {
        return _demo.getCreatorUserId();
    }

    /**
    * Sets the creator user ID of this demo.
    *
    * @param creatorUserId the creator user ID of this demo
    */
    @Override
    public void setCreatorUserId(long creatorUserId) {
        _demo.setCreatorUserId(creatorUserId);
    }

    /**
    * Returns the creator user uuid of this demo.
    *
    * @return the creator user uuid of this demo
    * @throws SystemException if a system exception occurred
    */
    @Override
    public java.lang.String getCreatorUserUuid()
        throws com.liferay.portal.kernel.exception.SystemException {
        return _demo.getCreatorUserUuid();
    }

    /**
    * Sets the creator user uuid of this demo.
    *
    * @param creatorUserUuid the creator user uuid of this demo
    */
    @Override
    public void setCreatorUserUuid(java.lang.String creatorUserUuid) {
        _demo.setCreatorUserUuid(creatorUserUuid);
    }

    /**
    * Returns the creator user name of this demo.
    *
    * @return the creator user name of this demo
    */
    @Override
    public java.lang.String getCreatorUserName() {
        return _demo.getCreatorUserName();
    }

    /**
    * Sets the creator user name of this demo.
    *
    * @param creatorUserName the creator user name of this demo
    */
    @Override
    public void setCreatorUserName(java.lang.String creatorUserName) {
        _demo.setCreatorUserName(creatorUserName);
    }

    /**
    * Returns the create date of this demo.
    *
    * @return the create date of this demo
    */
    @Override
    public java.util.Date getCreateDate() {
        return _demo.getCreateDate();
    }

    /**
    * Sets the create date of this demo.
    *
    * @param createDate the create date of this demo
    */
    @Override
    public void setCreateDate(java.util.Date createDate) {
        _demo.setCreateDate(createDate);
    }

    /**
    * Returns the modified date of this demo.
    *
    * @return the modified date of this demo
    */
    @Override
    public java.util.Date getModifiedDate() {
        return _demo.getModifiedDate();
    }

    /**
    * Sets the modified date of this demo.
    *
    * @param modifiedDate the modified date of this demo
    */
    @Override
    public void setModifiedDate(java.util.Date modifiedDate) {
        _demo.setModifiedDate(modifiedDate);
    }

    /**
    * Returns the text of this demo.
    *
    * @return the text of this demo
    */
    @Override
    public java.lang.String getText() {
        return _demo.getText();
    }

    /**
    * Sets the text of this demo.
    *
    * @param text the text of this demo
    */
    @Override
    public void setText(java.lang.String text) {
        _demo.setText(text);
    }

    @Override
    public boolean isNew() {
        return _demo.isNew();
    }

    @Override
    public void setNew(boolean n) {
        _demo.setNew(n);
    }

    @Override
    public boolean isCachedModel() {
        return _demo.isCachedModel();
    }

    @Override
    public void setCachedModel(boolean cachedModel) {
        _demo.setCachedModel(cachedModel);
    }

    @Override
    public boolean isEscapedModel() {
        return _demo.isEscapedModel();
    }

    @Override
    public java.io.Serializable getPrimaryKeyObj() {
        return _demo.getPrimaryKeyObj();
    }

    @Override
    public void setPrimaryKeyObj(java.io.Serializable primaryKeyObj) {
        _demo.setPrimaryKeyObj(primaryKeyObj);
    }

    @Override
    public com.liferay.portlet.expando.model.ExpandoBridge getExpandoBridge() {
        return _demo.getExpandoBridge();
    }

    @Override
    public void setExpandoBridgeAttributes(
        com.liferay.portal.model.BaseModel<?> baseModel) {
        _demo.setExpandoBridgeAttributes(baseModel);
    }

    @Override
    public void setExpandoBridgeAttributes(
        com.liferay.portlet.expando.model.ExpandoBridge expandoBridge) {
        _demo.setExpandoBridgeAttributes(expandoBridge);
    }

    @Override
    public void setExpandoBridgeAttributes(
        com.liferay.portal.service.ServiceContext serviceContext) {
        _demo.setExpandoBridgeAttributes(serviceContext);
    }

    @Override
    public java.lang.Object clone() {
        return new DemoWrapper((Demo) _demo.clone());
    }

    @Override
    public int compareTo(de.doubleslash.model.Demo demo) {
        return _demo.compareTo(demo);
    }

    @Override
    public int hashCode() {
        return _demo.hashCode();
    }

    @Override
    public com.liferay.portal.model.CacheModel<de.doubleslash.model.Demo> toCacheModel() {
        return _demo.toCacheModel();
    }

    @Override
    public de.doubleslash.model.Demo toEscapedModel() {
        return new DemoWrapper(_demo.toEscapedModel());
    }

    @Override
    public de.doubleslash.model.Demo toUnescapedModel() {
        return new DemoWrapper(_demo.toUnescapedModel());
    }

    @Override
    public java.lang.String toString() {
        return _demo.toString();
    }

    @Override
    public java.lang.String toXmlString() {
        return _demo.toXmlString();
    }

    @Override
    public void persist()
        throws com.liferay.portal.kernel.exception.SystemException {
        _demo.persist();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof DemoWrapper)) {
            return false;
        }

        DemoWrapper demoWrapper = (DemoWrapper) obj;

        if (Validator.equals(_demo, demoWrapper._demo)) {
            return true;
        }

        return false;
    }

    /**
     * @deprecated As of 6.1.0, replaced by {@link #getWrappedModel}
     */
    public Demo getWrappedDemo() {
        return _demo;
    }

    @Override
    public Demo getWrappedModel() {
        return _demo;
    }

    @Override
    public void resetOriginalValues() {
        _demo.resetOriginalValues();
    }
}
