package de.doubleslash.model.impl;

import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;

import de.doubleslash.model.Demo;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

import java.util.Date;

/**
 * The cache model class for representing Demo in entity cache.
 *
 * @author Brian Wing Shun Chan
 * @see Demo
 * @generated
 */
public class DemoCacheModel implements CacheModel<Demo>, Externalizable {
    public long demoId;
    public long creatorGroupId;
    public long creatorCompanyId;
    public long creatorUserId;
    public String creatorUserName;
    public long createDate;
    public long modifiedDate;
    public String text;

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(17);

        sb.append("{demoId=");
        sb.append(demoId);
        sb.append(", creatorGroupId=");
        sb.append(creatorGroupId);
        sb.append(", creatorCompanyId=");
        sb.append(creatorCompanyId);
        sb.append(", creatorUserId=");
        sb.append(creatorUserId);
        sb.append(", creatorUserName=");
        sb.append(creatorUserName);
        sb.append(", createDate=");
        sb.append(createDate);
        sb.append(", modifiedDate=");
        sb.append(modifiedDate);
        sb.append(", text=");
        sb.append(text);
        sb.append("}");

        return sb.toString();
    }

    @Override
    public Demo toEntityModel() {
        DemoImpl demoImpl = new DemoImpl();

        demoImpl.setDemoId(demoId);
        demoImpl.setCreatorGroupId(creatorGroupId);
        demoImpl.setCreatorCompanyId(creatorCompanyId);
        demoImpl.setCreatorUserId(creatorUserId);

        if (creatorUserName == null) {
            demoImpl.setCreatorUserName(StringPool.BLANK);
        } else {
            demoImpl.setCreatorUserName(creatorUserName);
        }

        if (createDate == Long.MIN_VALUE) {
            demoImpl.setCreateDate(null);
        } else {
            demoImpl.setCreateDate(new Date(createDate));
        }

        if (modifiedDate == Long.MIN_VALUE) {
            demoImpl.setModifiedDate(null);
        } else {
            demoImpl.setModifiedDate(new Date(modifiedDate));
        }

        if (text == null) {
            demoImpl.setText(StringPool.BLANK);
        } else {
            demoImpl.setText(text);
        }

        demoImpl.resetOriginalValues();

        return demoImpl;
    }

    @Override
    public void readExternal(ObjectInput objectInput) throws IOException {
        demoId = objectInput.readLong();
        creatorGroupId = objectInput.readLong();
        creatorCompanyId = objectInput.readLong();
        creatorUserId = objectInput.readLong();
        creatorUserName = objectInput.readUTF();
        createDate = objectInput.readLong();
        modifiedDate = objectInput.readLong();
        text = objectInput.readUTF();
    }

    @Override
    public void writeExternal(ObjectOutput objectOutput)
        throws IOException {
        objectOutput.writeLong(demoId);
        objectOutput.writeLong(creatorGroupId);
        objectOutput.writeLong(creatorCompanyId);
        objectOutput.writeLong(creatorUserId);

        if (creatorUserName == null) {
            objectOutput.writeUTF(StringPool.BLANK);
        } else {
            objectOutput.writeUTF(creatorUserName);
        }

        objectOutput.writeLong(createDate);
        objectOutput.writeLong(modifiedDate);

        if (text == null) {
            objectOutput.writeUTF(StringPool.BLANK);
        } else {
            objectOutput.writeUTF(text);
        }
    }
}
