package de.doubleslash.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.json.JSON;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.doubleslash.model.Demo;
import de.doubleslash.model.DemoModel;
import de.doubleslash.model.DemoSoap;

import java.io.Serializable;

import java.sql.Types;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * The base model implementation for the Demo service. Represents a row in the &quot;Demo_Demo&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.doubleslash.model.DemoModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link DemoImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see DemoImpl
 * @see de.doubleslash.model.Demo
 * @see de.doubleslash.model.DemoModel
 * @generated
 */
@JSON(strict = true)
public class DemoModelImpl extends BaseModelImpl<Demo> implements DemoModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a demo model instance should use the {@link de.doubleslash.model.Demo} interface instead.
     */
    public static final String TABLE_NAME = "Demo_Demo";
    public static final Object[][] TABLE_COLUMNS = {
            { "demoId", Types.BIGINT },
            { "creatorGroupId", Types.BIGINT },
            { "creatorCompanyId", Types.BIGINT },
            { "creatorUserId", Types.BIGINT },
            { "creatorUserName", Types.VARCHAR },
            { "createDate", Types.TIMESTAMP },
            { "modifiedDate", Types.TIMESTAMP },
            { "text_", Types.VARCHAR }
        };
    public static final String TABLE_SQL_CREATE = "create table Demo_Demo (demoId LONG not null primary key IDENTITY,creatorGroupId LONG,creatorCompanyId LONG,creatorUserId LONG,creatorUserName VARCHAR(75) null,createDate DATE null,modifiedDate DATE null,text_ VARCHAR(75) null)";
    public static final String TABLE_SQL_DROP = "drop table Demo_Demo";
    public static final String ORDER_BY_JPQL = " ORDER BY demo.demoId ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Demo_Demo.demoId ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.doubleslash.model.Demo"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.doubleslash.model.Demo"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.doubleslash.model.Demo"),
            true);
    public static long DEMOID_COLUMN_BITMASK = 1L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.doubleslash.model.Demo"));
    private static ClassLoader _classLoader = Demo.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] { Demo.class };
    private long _demoId;
    private long _originalDemoId;
    private boolean _setOriginalDemoId;
    private long _creatorGroupId;
    private long _creatorCompanyId;
    private long _creatorUserId;
    private String _creatorUserUuid;
    private String _creatorUserName;
    private Date _createDate;
    private Date _modifiedDate;
    private String _text;
    private long _columnBitmask;
    private Demo _escapedModel;

    public DemoModelImpl() {
    }

    /**
     * Converts the soap model instance into a normal model instance.
     *
     * @param soapModel the soap model instance to convert
     * @return the normal model instance
     */
    public static Demo toModel(DemoSoap soapModel) {
        if (soapModel == null) {
            return null;
        }

        Demo model = new DemoImpl();

        model.setDemoId(soapModel.getDemoId());
        model.setCreatorGroupId(soapModel.getCreatorGroupId());
        model.setCreatorCompanyId(soapModel.getCreatorCompanyId());
        model.setCreatorUserId(soapModel.getCreatorUserId());
        model.setCreatorUserName(soapModel.getCreatorUserName());
        model.setCreateDate(soapModel.getCreateDate());
        model.setModifiedDate(soapModel.getModifiedDate());
        model.setText(soapModel.getText());

        return model;
    }

    /**
     * Converts the soap model instances into normal model instances.
     *
     * @param soapModels the soap model instances to convert
     * @return the normal model instances
     */
    public static List<Demo> toModels(DemoSoap[] soapModels) {
        if (soapModels == null) {
            return null;
        }

        List<Demo> models = new ArrayList<Demo>(soapModels.length);

        for (DemoSoap soapModel : soapModels) {
            models.add(toModel(soapModel));
        }

        return models;
    }

    @Override
    public long getPrimaryKey() {
        return _demoId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setDemoId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _demoId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return Demo.class;
    }

    @Override
    public String getModelClassName() {
        return Demo.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("demoId", getDemoId());
        attributes.put("creatorGroupId", getCreatorGroupId());
        attributes.put("creatorCompanyId", getCreatorCompanyId());
        attributes.put("creatorUserId", getCreatorUserId());
        attributes.put("creatorUserName", getCreatorUserName());
        attributes.put("createDate", getCreateDate());
        attributes.put("modifiedDate", getModifiedDate());
        attributes.put("text", getText());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long demoId = (Long) attributes.get("demoId");

        if (demoId != null) {
            setDemoId(demoId);
        }

        Long creatorGroupId = (Long) attributes.get("creatorGroupId");

        if (creatorGroupId != null) {
            setCreatorGroupId(creatorGroupId);
        }

        Long creatorCompanyId = (Long) attributes.get("creatorCompanyId");

        if (creatorCompanyId != null) {
            setCreatorCompanyId(creatorCompanyId);
        }

        Long creatorUserId = (Long) attributes.get("creatorUserId");

        if (creatorUserId != null) {
            setCreatorUserId(creatorUserId);
        }

        String creatorUserName = (String) attributes.get("creatorUserName");

        if (creatorUserName != null) {
            setCreatorUserName(creatorUserName);
        }

        Date createDate = (Date) attributes.get("createDate");

        if (createDate != null) {
            setCreateDate(createDate);
        }

        Date modifiedDate = (Date) attributes.get("modifiedDate");

        if (modifiedDate != null) {
            setModifiedDate(modifiedDate);
        }

        String text = (String) attributes.get("text");

        if (text != null) {
            setText(text);
        }
    }

    @JSON
    @Override
    public long getDemoId() {
        return _demoId;
    }

    @Override
    public void setDemoId(long demoId) {
        _columnBitmask = -1L;

        if (!_setOriginalDemoId) {
            _setOriginalDemoId = true;

            _originalDemoId = _demoId;
        }

        _demoId = demoId;
    }

    public long getOriginalDemoId() {
        return _originalDemoId;
    }

    @JSON
    @Override
    public long getCreatorGroupId() {
        return _creatorGroupId;
    }

    @Override
    public void setCreatorGroupId(long creatorGroupId) {
        _creatorGroupId = creatorGroupId;
    }

    @JSON
    @Override
    public long getCreatorCompanyId() {
        return _creatorCompanyId;
    }

    @Override
    public void setCreatorCompanyId(long creatorCompanyId) {
        _creatorCompanyId = creatorCompanyId;
    }

    @JSON
    @Override
    public long getCreatorUserId() {
        return _creatorUserId;
    }

    @Override
    public void setCreatorUserId(long creatorUserId) {
        _creatorUserId = creatorUserId;
    }

    @Override
    public String getCreatorUserUuid() throws SystemException {
        return PortalUtil.getUserValue(getCreatorUserId(), "uuid",
            _creatorUserUuid);
    }

    @Override
    public void setCreatorUserUuid(String creatorUserUuid) {
        _creatorUserUuid = creatorUserUuid;
    }

    @JSON
    @Override
    public String getCreatorUserName() {
        if (_creatorUserName == null) {
            return StringPool.BLANK;
        } else {
            return _creatorUserName;
        }
    }

    @Override
    public void setCreatorUserName(String creatorUserName) {
        _creatorUserName = creatorUserName;
    }

    @JSON
    @Override
    public Date getCreateDate() {
        return _createDate;
    }

    @Override
    public void setCreateDate(Date createDate) {
        _createDate = createDate;
    }

    @JSON
    @Override
    public Date getModifiedDate() {
        return _modifiedDate;
    }

    @Override
    public void setModifiedDate(Date modifiedDate) {
        _modifiedDate = modifiedDate;
    }

    @JSON
    @Override
    public String getText() {
        if (_text == null) {
            return StringPool.BLANK;
        } else {
            return _text;
        }
    }

    @Override
    public void setText(String text) {
        _text = text;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            Demo.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public Demo toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (Demo) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        DemoImpl demoImpl = new DemoImpl();

        demoImpl.setDemoId(getDemoId());
        demoImpl.setCreatorGroupId(getCreatorGroupId());
        demoImpl.setCreatorCompanyId(getCreatorCompanyId());
        demoImpl.setCreatorUserId(getCreatorUserId());
        demoImpl.setCreatorUserName(getCreatorUserName());
        demoImpl.setCreateDate(getCreateDate());
        demoImpl.setModifiedDate(getModifiedDate());
        demoImpl.setText(getText());

        demoImpl.resetOriginalValues();

        return demoImpl;
    }

    @Override
    public int compareTo(Demo demo) {
        int value = 0;

        if (getDemoId() < demo.getDemoId()) {
            value = -1;
        } else if (getDemoId() > demo.getDemoId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof Demo)) {
            return false;
        }

        Demo demo = (Demo) obj;

        long primaryKey = demo.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        DemoModelImpl demoModelImpl = this;

        demoModelImpl._originalDemoId = demoModelImpl._demoId;

        demoModelImpl._setOriginalDemoId = false;

        demoModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<Demo> toCacheModel() {
        DemoCacheModel demoCacheModel = new DemoCacheModel();

        demoCacheModel.demoId = getDemoId();

        demoCacheModel.creatorGroupId = getCreatorGroupId();

        demoCacheModel.creatorCompanyId = getCreatorCompanyId();

        demoCacheModel.creatorUserId = getCreatorUserId();

        demoCacheModel.creatorUserName = getCreatorUserName();

        String creatorUserName = demoCacheModel.creatorUserName;

        if ((creatorUserName != null) && (creatorUserName.length() == 0)) {
            demoCacheModel.creatorUserName = null;
        }

        Date createDate = getCreateDate();

        if (createDate != null) {
            demoCacheModel.createDate = createDate.getTime();
        } else {
            demoCacheModel.createDate = Long.MIN_VALUE;
        }

        Date modifiedDate = getModifiedDate();

        if (modifiedDate != null) {
            demoCacheModel.modifiedDate = modifiedDate.getTime();
        } else {
            demoCacheModel.modifiedDate = Long.MIN_VALUE;
        }

        demoCacheModel.text = getText();

        String text = demoCacheModel.text;

        if ((text != null) && (text.length() == 0)) {
            demoCacheModel.text = null;
        }

        return demoCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(17);

        sb.append("{demoId=");
        sb.append(getDemoId());
        sb.append(", creatorGroupId=");
        sb.append(getCreatorGroupId());
        sb.append(", creatorCompanyId=");
        sb.append(getCreatorCompanyId());
        sb.append(", creatorUserId=");
        sb.append(getCreatorUserId());
        sb.append(", creatorUserName=");
        sb.append(getCreatorUserName());
        sb.append(", createDate=");
        sb.append(getCreateDate());
        sb.append(", modifiedDate=");
        sb.append(getModifiedDate());
        sb.append(", text=");
        sb.append(getText());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(28);

        sb.append("<model><model-name>");
        sb.append("de.doubleslash.model.Demo");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>demoId</column-name><column-value><![CDATA[");
        sb.append(getDemoId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorGroupId</column-name><column-value><![CDATA[");
        sb.append(getCreatorGroupId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorCompanyId</column-name><column-value><![CDATA[");
        sb.append(getCreatorCompanyId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorUserId</column-name><column-value><![CDATA[");
        sb.append(getCreatorUserId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorUserName</column-name><column-value><![CDATA[");
        sb.append(getCreatorUserName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>createDate</column-name><column-value><![CDATA[");
        sb.append(getCreateDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
        sb.append(getModifiedDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>text</column-name><column-value><![CDATA[");
        sb.append(getText());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
