package de.doubleslash.service;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ReferenceRegistry;
import com.liferay.portal.service.InvokableService;

/**
 * Provides the remote service utility for Demo. This utility wraps
 * {@link de.doubleslash.service.impl.DemoServiceImpl} and is the
 * primary access point for service operations in application layer code running
 * on a remote server. Methods of this service are expected to have security
 * checks based on the propagated JAAS credentials because this service can be
 * accessed remotely.
 *
 * @author Brian Wing Shun Chan
 * @see DemoService
 * @see de.doubleslash.service.base.DemoServiceBaseImpl
 * @see de.doubleslash.service.impl.DemoServiceImpl
 * @generated
 */
public class DemoServiceUtil {
    private static DemoService _service;

    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify this class directly. Add custom service methods to {@link de.doubleslash.service.impl.DemoServiceImpl} and rerun ServiceBuilder to regenerate this class.
     */

    /**
    * Returns the Spring bean ID for this bean.
    *
    * @return the Spring bean ID for this bean
    */
    public static java.lang.String getBeanIdentifier() {
        return getService().getBeanIdentifier();
    }

    /**
    * Sets the Spring bean ID for this bean.
    *
    * @param beanIdentifier the Spring bean ID for this bean
    */
    public static void setBeanIdentifier(java.lang.String beanIdentifier) {
        getService().setBeanIdentifier(beanIdentifier);
    }

    public static java.lang.Object invokeMethod(java.lang.String name,
        java.lang.String[] parameterTypes, java.lang.Object[] arguments)
        throws java.lang.Throwable {
        return getService().invokeMethod(name, parameterTypes, arguments);
    }

    /**
    * @param demoId
    * @return
    * @throws com.liferay.portal.kernel.exception.PortalException
    * @throws com.liferay.portal.kernel.exception.SystemException
    */
    public static de.doubleslash.model.Demo getDemo(long demoId)
        throws com.liferay.portal.kernel.exception.PortalException,
            com.liferay.portal.kernel.exception.SystemException {
        return getService().getDemo(demoId);
    }

    public static void clearService() {
        _service = null;
    }

    public static DemoService getService() {
        if (_service == null) {
            InvokableService invokableService = (InvokableService) PortletBeanLocatorUtil.locate(ClpSerializer.getServletContextName(),
                    DemoService.class.getName());

            if (invokableService instanceof DemoService) {
                _service = (DemoService) invokableService;
            } else {
                _service = new DemoServiceClp(invokableService);
            }

            ReferenceRegistry.registerReference(DemoServiceUtil.class,
                "_service");
        }

        return _service;
    }

    /**
     * @deprecated As of 6.2.0
     */
    public void setService(DemoService service) {
    }
}
