package de.doubleslash.service.base;

import com.liferay.portal.kernel.bean.BeanReference;
import com.liferay.portal.kernel.bean.IdentifiableBean;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdate;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdateFactoryUtil;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.service.BaseServiceImpl;
import com.liferay.portal.service.persistence.UserPersistence;

import de.doubleslash.model.Demo;

import de.doubleslash.service.DemoService;
import de.doubleslash.service.persistence.DemoPersistence;

import javax.sql.DataSource;

/**
 * Provides the base implementation for the demo remote service.
 *
 * <p>
 * This implementation exists only as a container for the default service methods generated by ServiceBuilder. All custom service methods should be put in {@link de.doubleslash.service.impl.DemoServiceImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see de.doubleslash.service.impl.DemoServiceImpl
 * @see de.doubleslash.service.DemoServiceUtil
 * @generated
 */
public abstract class DemoServiceBaseImpl extends BaseServiceImpl
    implements DemoService, IdentifiableBean {
    @BeanReference(type = de.doubleslash.service.DemoLocalService.class)
    protected de.doubleslash.service.DemoLocalService demoLocalService;
    @BeanReference(type = de.doubleslash.service.DemoService.class)
    protected de.doubleslash.service.DemoService demoService;
    @BeanReference(type = DemoPersistence.class)
    protected DemoPersistence demoPersistence;
    @BeanReference(type = com.liferay.counter.service.CounterLocalService.class)
    protected com.liferay.counter.service.CounterLocalService counterLocalService;
    @BeanReference(type = com.liferay.portal.service.ResourceLocalService.class)
    protected com.liferay.portal.service.ResourceLocalService resourceLocalService;
    @BeanReference(type = com.liferay.portal.service.UserLocalService.class)
    protected com.liferay.portal.service.UserLocalService userLocalService;
    @BeanReference(type = com.liferay.portal.service.UserService.class)
    protected com.liferay.portal.service.UserService userService;
    @BeanReference(type = UserPersistence.class)
    protected UserPersistence userPersistence;
    private String _beanIdentifier;
    private ClassLoader _classLoader;
    private DemoServiceClpInvoker _clpInvoker = new DemoServiceClpInvoker();

    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. Always use {@link de.doubleslash.service.DemoServiceUtil} to access the demo remote service.
     */

    /**
     * Returns the demo local service.
     *
     * @return the demo local service
     */
    public de.doubleslash.service.DemoLocalService getDemoLocalService() {
        return demoLocalService;
    }

    /**
     * Sets the demo local service.
     *
     * @param demoLocalService the demo local service
     */
    public void setDemoLocalService(
        de.doubleslash.service.DemoLocalService demoLocalService) {
        this.demoLocalService = demoLocalService;
    }

    /**
     * Returns the demo remote service.
     *
     * @return the demo remote service
     */
    public de.doubleslash.service.DemoService getDemoService() {
        return demoService;
    }

    /**
     * Sets the demo remote service.
     *
     * @param demoService the demo remote service
     */
    public void setDemoService(de.doubleslash.service.DemoService demoService) {
        this.demoService = demoService;
    }

    /**
     * Returns the demo persistence.
     *
     * @return the demo persistence
     */
    public DemoPersistence getDemoPersistence() {
        return demoPersistence;
    }

    /**
     * Sets the demo persistence.
     *
     * @param demoPersistence the demo persistence
     */
    public void setDemoPersistence(DemoPersistence demoPersistence) {
        this.demoPersistence = demoPersistence;
    }

    /**
     * Returns the counter local service.
     *
     * @return the counter local service
     */
    public com.liferay.counter.service.CounterLocalService getCounterLocalService() {
        return counterLocalService;
    }

    /**
     * Sets the counter local service.
     *
     * @param counterLocalService the counter local service
     */
    public void setCounterLocalService(
        com.liferay.counter.service.CounterLocalService counterLocalService) {
        this.counterLocalService = counterLocalService;
    }

    /**
     * Returns the resource local service.
     *
     * @return the resource local service
     */
    public com.liferay.portal.service.ResourceLocalService getResourceLocalService() {
        return resourceLocalService;
    }

    /**
     * Sets the resource local service.
     *
     * @param resourceLocalService the resource local service
     */
    public void setResourceLocalService(
        com.liferay.portal.service.ResourceLocalService resourceLocalService) {
        this.resourceLocalService = resourceLocalService;
    }

    /**
     * Returns the user local service.
     *
     * @return the user local service
     */
    public com.liferay.portal.service.UserLocalService getUserLocalService() {
        return userLocalService;
    }

    /**
     * Sets the user local service.
     *
     * @param userLocalService the user local service
     */
    public void setUserLocalService(
        com.liferay.portal.service.UserLocalService userLocalService) {
        this.userLocalService = userLocalService;
    }

    /**
     * Returns the user remote service.
     *
     * @return the user remote service
     */
    public com.liferay.portal.service.UserService getUserService() {
        return userService;
    }

    /**
     * Sets the user remote service.
     *
     * @param userService the user remote service
     */
    public void setUserService(
        com.liferay.portal.service.UserService userService) {
        this.userService = userService;
    }

    /**
     * Returns the user persistence.
     *
     * @return the user persistence
     */
    public UserPersistence getUserPersistence() {
        return userPersistence;
    }

    /**
     * Sets the user persistence.
     *
     * @param userPersistence the user persistence
     */
    public void setUserPersistence(UserPersistence userPersistence) {
        this.userPersistence = userPersistence;
    }

    public void afterPropertiesSet() {
        Class<?> clazz = getClass();

        _classLoader = clazz.getClassLoader();
    }

    public void destroy() {
    }

    /**
     * Returns the Spring bean ID for this bean.
     *
     * @return the Spring bean ID for this bean
     */
    @Override
    public String getBeanIdentifier() {
        return _beanIdentifier;
    }

    /**
     * Sets the Spring bean ID for this bean.
     *
     * @param beanIdentifier the Spring bean ID for this bean
     */
    @Override
    public void setBeanIdentifier(String beanIdentifier) {
        _beanIdentifier = beanIdentifier;
    }

    @Override
    public Object invokeMethod(String name, String[] parameterTypes,
        Object[] arguments) throws Throwable {
        Thread currentThread = Thread.currentThread();

        ClassLoader contextClassLoader = currentThread.getContextClassLoader();

        if (contextClassLoader != _classLoader) {
            currentThread.setContextClassLoader(_classLoader);
        }

        try {
            return _clpInvoker.invokeMethod(name, parameterTypes, arguments);
        } finally {
            if (contextClassLoader != _classLoader) {
                currentThread.setContextClassLoader(contextClassLoader);
            }
        }
    }

    protected Class<?> getModelClass() {
        return Demo.class;
    }

    protected String getModelClassName() {
        return Demo.class.getName();
    }

    /**
     * Performs an SQL query.
     *
     * @param sql the sql query
     */
    protected void runSQL(String sql) throws SystemException {
        try {
            DataSource dataSource = demoPersistence.getDataSource();

            SqlUpdate sqlUpdate = SqlUpdateFactoryUtil.getSqlUpdate(dataSource,
                    sql, new int[0]);

            sqlUpdate.update();
        } catch (Exception e) {
            throw new SystemException(e);
        }
    }
}
