package de.doubleslash.service.http;

import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;

import de.doubleslash.service.DemoServiceUtil;

import java.rmi.RemoteException;

/**
 * Provides the SOAP utility for the
 * {@link de.doubleslash.service.DemoServiceUtil} service utility. The
 * static methods of this class calls the same methods of the service utility.
 * However, the signatures are different because it is difficult for SOAP to
 * support certain types.
 *
 * <p>
 * ServiceBuilder follows certain rules in translating the methods. For example,
 * if the method in the service utility returns a {@link java.util.List}, that
 * is translated to an array of {@link de.doubleslash.model.DemoSoap}.
 * If the method in the service utility returns a
 * {@link de.doubleslash.model.Demo}, that is translated to a
 * {@link de.doubleslash.model.DemoSoap}. Methods that SOAP cannot
 * safely wire are skipped.
 * </p>
 *
 * <p>
 * The benefits of using the SOAP utility is that it is cross platform
 * compatible. SOAP allows different languages like Java, .NET, C++, PHP, and
 * even Perl, to call the generated services. One drawback of SOAP is that it is
 * slow because it needs to serialize all calls into a text format (XML).
 * </p>
 *
 * <p>
 * You can see a list of services at http://localhost:8080/api/axis. Set the
 * property <b>axis.servlet.hosts.allowed</b> in portal.properties to configure
 * security.
 * </p>
 *
 * <p>
 * The SOAP utility is only generated for remote services.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see DemoServiceHttp
 * @see de.doubleslash.model.DemoSoap
 * @see de.doubleslash.service.DemoServiceUtil
 * @generated
 */
public class DemoServiceSoap {
    private static Log _log = LogFactoryUtil.getLog(DemoServiceSoap.class);

    /**
    * @param demoId
    * @return
    * @throws com.liferay.portal.kernel.exception.PortalException
    * @throws com.liferay.portal.kernel.exception.SystemException
    */
    public static de.doubleslash.model.DemoSoap getDemo(long demoId)
        throws RemoteException {
        try {
            de.doubleslash.model.Demo returnValue = DemoServiceUtil.getDemo(demoId);

            return de.doubleslash.model.DemoSoap.toSoapModel(returnValue);
        } catch (Exception e) {
            _log.error(e, e);

            throw new RemoteException(e.getMessage());
        }
    }
}
