package de.doubleslash.service.impl;

import de.doubleslash.service.base.DemoLocalServiceBaseImpl;

/**
 * The implementation of the demo local service.
 *
 * <p>
 * All custom service methods should be put in this class. Whenever methods are added, rerun ServiceBuilder to copy their definitions into the {@link de.doubleslash.service.DemoLocalService} interface.
 *
 * <p>
 * This is a local service. Methods of this service will not have security checks based on the propagated JAAS credentials because this service can only be accessed from within the same VM.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see de.doubleslash.service.base.DemoLocalServiceBaseImpl
 * @see de.doubleslash.service.DemoLocalServiceUtil
 */
public class DemoLocalServiceImpl extends DemoLocalServiceBaseImpl {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never reference this interface directly. Always use {@link de.doubleslash.service.DemoLocalServiceUtil} to access the demo local service.
     */
}
