package de.doubleslash.service.impl;

import de.doubleslash.model.Demo;
import de.doubleslash.service.DemoLocalServiceUtil;
import de.doubleslash.service.base.DemoServiceBaseImpl;

/**
 * The implementation of the demo remote service.
 *
 * <p>
 * All custom service methods should be put in this class. Whenever methods are added, rerun ServiceBuilder to copy
 * their definitions into the {@link de.doubleslash.service.DemoService} interface.
 *
 * <p>
 * This is a remote service. Methods of this service are expected to have security checks based on the propagated JAAS
 * credentials because this service can be accessed remotely.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see de.doubleslash.service.base.DemoServiceBaseImpl
 * @see de.doubleslash.service.DemoServiceUtil
 */
public class DemoServiceImpl extends DemoServiceBaseImpl {
   /*
    * NOTE FOR DEVELOPERS:
    *
    * Never reference this interface directly. Always use {@link de.doubleslash.service.DemoServiceUtil} to access the demo remote service.
    */

   /**
    * 
    * @param demoId
    * @return
    * @throws com.liferay.portal.kernel.exception.PortalException
    * @throws com.liferay.portal.kernel.exception.SystemException
    */
   public Demo getDemo(long demoId) throws com.liferay.portal.kernel.exception.PortalException,
         com.liferay.portal.kernel.exception.SystemException {

      return DemoLocalServiceUtil.getDemo(demoId);
   }
}
