package de.doubleslash.service.persistence;

import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryPos;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PropsKeys;
import com.liferay.portal.kernel.util.PropsUtil;
import com.liferay.portal.kernel.util.SetUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.kernel.util.UnmodifiableList;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import de.doubleslash.NoSuchDemoException;

import de.doubleslash.model.Demo;
import de.doubleslash.model.impl.DemoImpl;
import de.doubleslash.model.impl.DemoModelImpl;

import de.doubleslash.service.persistence.DemoPersistence;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Set;

/**
 * The persistence implementation for the demo service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see DemoPersistence
 * @see DemoUtil
 * @generated
 */
public class DemoPersistenceImpl extends BasePersistenceImpl<Demo>
    implements DemoPersistence {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. Always use {@link DemoUtil} to access the demo persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
     */
    public static final String FINDER_CLASS_NAME_ENTITY = DemoImpl.class.getName();
    public static final String FINDER_CLASS_NAME_LIST_WITH_PAGINATION = FINDER_CLASS_NAME_ENTITY +
        ".List1";
    public static final String FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION = FINDER_CLASS_NAME_ENTITY +
        ".List2";
    public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_ALL = new FinderPath(DemoModelImpl.ENTITY_CACHE_ENABLED,
            DemoModelImpl.FINDER_CACHE_ENABLED, DemoImpl.class,
            FINDER_CLASS_NAME_LIST_WITH_PAGINATION, "findAll", new String[0]);
    public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL = new FinderPath(DemoModelImpl.ENTITY_CACHE_ENABLED,
            DemoModelImpl.FINDER_CACHE_ENABLED, DemoImpl.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "findAll", new String[0]);
    public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(DemoModelImpl.ENTITY_CACHE_ENABLED,
            DemoModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countAll", new String[0]);
    public static final FinderPath FINDER_PATH_FETCH_BY_DEMOID = new FinderPath(DemoModelImpl.ENTITY_CACHE_ENABLED,
            DemoModelImpl.FINDER_CACHE_ENABLED, DemoImpl.class,
            FINDER_CLASS_NAME_ENTITY, "fetchBydemoId",
            new String[] { Long.class.getName() },
            DemoModelImpl.DEMOID_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_DEMOID = new FinderPath(DemoModelImpl.ENTITY_CACHE_ENABLED,
            DemoModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countBydemoId",
            new String[] { Long.class.getName() });
    private static final String _FINDER_COLUMN_DEMOID_DEMOID_2 = "demo.demoId = ?";
    private static final String _SQL_SELECT_DEMO = "SELECT demo FROM Demo demo";
    private static final String _SQL_SELECT_DEMO_WHERE = "SELECT demo FROM Demo demo WHERE ";
    private static final String _SQL_COUNT_DEMO = "SELECT COUNT(demo) FROM Demo demo";
    private static final String _SQL_COUNT_DEMO_WHERE = "SELECT COUNT(demo) FROM Demo demo WHERE ";
    private static final String _ORDER_BY_ENTITY_ALIAS = "demo.";
    private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No Demo exists with the primary key ";
    private static final String _NO_SUCH_ENTITY_WITH_KEY = "No Demo exists with the key {";
    private static final boolean _HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE = GetterUtil.getBoolean(PropsUtil.get(
                PropsKeys.HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE));
    private static Log _log = LogFactoryUtil.getLog(DemoPersistenceImpl.class);
    private static Set<String> _badColumnNames = SetUtil.fromArray(new String[] {
                "text"
            });
    private static Demo _nullDemo = new DemoImpl() {
            @Override
            public Object clone() {
                return this;
            }

            @Override
            public CacheModel<Demo> toCacheModel() {
                return _nullDemoCacheModel;
            }
        };

    private static CacheModel<Demo> _nullDemoCacheModel = new CacheModel<Demo>() {
            @Override
            public Demo toEntityModel() {
                return _nullDemo;
            }
        };

    public DemoPersistenceImpl() {
        setModelClass(Demo.class);
    }

    /**
     * Returns the demo where demoId = &#63; or throws a {@link de.doubleslash.NoSuchDemoException} if it could not be found.
     *
     * @param demoId the demo ID
     * @return the matching demo
     * @throws de.doubleslash.NoSuchDemoException if a matching demo could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Demo findBydemoId(long demoId)
        throws NoSuchDemoException, SystemException {
        Demo demo = fetchBydemoId(demoId);

        if (demo == null) {
            StringBundler msg = new StringBundler(4);

            msg.append(_NO_SUCH_ENTITY_WITH_KEY);

            msg.append("demoId=");
            msg.append(demoId);

            msg.append(StringPool.CLOSE_CURLY_BRACE);

            if (_log.isWarnEnabled()) {
                _log.warn(msg.toString());
            }

            throw new NoSuchDemoException(msg.toString());
        }

        return demo;
    }

    /**
     * Returns the demo where demoId = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
     *
     * @param demoId the demo ID
     * @return the matching demo, or <code>null</code> if a matching demo could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Demo fetchBydemoId(long demoId) throws SystemException {
        return fetchBydemoId(demoId, true);
    }

    /**
     * Returns the demo where demoId = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
     *
     * @param demoId the demo ID
     * @param retrieveFromCache whether to use the finder cache
     * @return the matching demo, or <code>null</code> if a matching demo could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Demo fetchBydemoId(long demoId, boolean retrieveFromCache)
        throws SystemException {
        Object[] finderArgs = new Object[] { demoId };

        Object result = null;

        if (retrieveFromCache) {
            result = FinderCacheUtil.getResult(FINDER_PATH_FETCH_BY_DEMOID,
                    finderArgs, this);
        }

        if (result instanceof Demo) {
            Demo demo = (Demo) result;

            if ((demoId != demo.getDemoId())) {
                result = null;
            }
        }

        if (result == null) {
            StringBundler query = new StringBundler(3);

            query.append(_SQL_SELECT_DEMO_WHERE);

            query.append(_FINDER_COLUMN_DEMOID_DEMOID_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                qPos.add(demoId);

                List<Demo> list = q.list();

                if (list.isEmpty()) {
                    FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_DEMOID,
                        finderArgs, list);
                } else {
                    if ((list.size() > 1) && _log.isWarnEnabled()) {
                        _log.warn(
                            "DemoPersistenceImpl.fetchBydemoId(long, boolean) with parameters (" +
                            StringUtil.merge(finderArgs) +
                            ") yields a result set with more than 1 result. This violates the logical unique restriction. There is no order guarantee on which result is returned by this finder.");
                    }

                    Demo demo = list.get(0);

                    result = demo;

                    cacheResult(demo);

                    if ((demo.getDemoId() != demoId)) {
                        FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_DEMOID,
                            finderArgs, demo);
                    }
                }
            } catch (Exception e) {
                FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_DEMOID,
                    finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        if (result instanceof List<?>) {
            return null;
        } else {
            return (Demo) result;
        }
    }

    /**
     * Removes the demo where demoId = &#63; from the database.
     *
     * @param demoId the demo ID
     * @return the demo that was removed
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Demo removeBydemoId(long demoId)
        throws NoSuchDemoException, SystemException {
        Demo demo = findBydemoId(demoId);

        return remove(demo);
    }

    /**
     * Returns the number of demos where demoId = &#63;.
     *
     * @param demoId the demo ID
     * @return the number of matching demos
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countBydemoId(long demoId) throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_DEMOID;

        Object[] finderArgs = new Object[] { demoId };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(2);

            query.append(_SQL_COUNT_DEMO_WHERE);

            query.append(_FINDER_COLUMN_DEMOID_DEMOID_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                qPos.add(demoId);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Caches the demo in the entity cache if it is enabled.
     *
     * @param demo the demo
     */
    @Override
    public void cacheResult(Demo demo) {
        EntityCacheUtil.putResult(DemoModelImpl.ENTITY_CACHE_ENABLED,
            DemoImpl.class, demo.getPrimaryKey(), demo);

        FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_DEMOID,
            new Object[] { demo.getDemoId() }, demo);

        demo.resetOriginalValues();
    }

    /**
     * Caches the demos in the entity cache if it is enabled.
     *
     * @param demos the demos
     */
    @Override
    public void cacheResult(List<Demo> demos) {
        for (Demo demo : demos) {
            if (EntityCacheUtil.getResult(DemoModelImpl.ENTITY_CACHE_ENABLED,
                        DemoImpl.class, demo.getPrimaryKey()) == null) {
                cacheResult(demo);
            } else {
                demo.resetOriginalValues();
            }
        }
    }

    /**
     * Clears the cache for all demos.
     *
     * <p>
     * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
     * </p>
     */
    @Override
    public void clearCache() {
        if (_HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE) {
            CacheRegistryUtil.clear(DemoImpl.class.getName());
        }

        EntityCacheUtil.clearCache(DemoImpl.class.getName());

        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
    }

    /**
     * Clears the cache for the demo.
     *
     * <p>
     * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
     * </p>
     */
    @Override
    public void clearCache(Demo demo) {
        EntityCacheUtil.removeResult(DemoModelImpl.ENTITY_CACHE_ENABLED,
            DemoImpl.class, demo.getPrimaryKey());

        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

        clearUniqueFindersCache(demo);
    }

    @Override
    public void clearCache(List<Demo> demos) {
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

        for (Demo demo : demos) {
            EntityCacheUtil.removeResult(DemoModelImpl.ENTITY_CACHE_ENABLED,
                DemoImpl.class, demo.getPrimaryKey());

            clearUniqueFindersCache(demo);
        }
    }

    protected void cacheUniqueFindersCache(Demo demo) {
        if (demo.isNew()) {
            Object[] args = new Object[] { demo.getDemoId() };

            FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_DEMOID, args,
                Long.valueOf(1));
            FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_DEMOID, args, demo);
        } else {
            DemoModelImpl demoModelImpl = (DemoModelImpl) demo;

            if ((demoModelImpl.getColumnBitmask() &
                    FINDER_PATH_FETCH_BY_DEMOID.getColumnBitmask()) != 0) {
                Object[] args = new Object[] { demo.getDemoId() };

                FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_DEMOID, args,
                    Long.valueOf(1));
                FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_DEMOID, args,
                    demo);
            }
        }
    }

    protected void clearUniqueFindersCache(Demo demo) {
        DemoModelImpl demoModelImpl = (DemoModelImpl) demo;

        Object[] args = new Object[] { demo.getDemoId() };

        FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_DEMOID, args);
        FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_DEMOID, args);

        if ((demoModelImpl.getColumnBitmask() &
                FINDER_PATH_FETCH_BY_DEMOID.getColumnBitmask()) != 0) {
            args = new Object[] { demoModelImpl.getOriginalDemoId() };

            FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_DEMOID, args);
            FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_DEMOID, args);
        }
    }

    /**
     * Creates a new demo with the primary key. Does not add the demo to the database.
     *
     * @param demoId the primary key for the new demo
     * @return the new demo
     */
    @Override
    public Demo create(long demoId) {
        Demo demo = new DemoImpl();

        demo.setNew(true);
        demo.setPrimaryKey(demoId);

        return demo;
    }

    /**
     * Removes the demo with the primary key from the database. Also notifies the appropriate model listeners.
     *
     * @param demoId the primary key of the demo
     * @return the demo that was removed
     * @throws de.doubleslash.NoSuchDemoException if a demo with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Demo remove(long demoId) throws NoSuchDemoException, SystemException {
        return remove((Serializable) demoId);
    }

    /**
     * Removes the demo with the primary key from the database. Also notifies the appropriate model listeners.
     *
     * @param primaryKey the primary key of the demo
     * @return the demo that was removed
     * @throws de.doubleslash.NoSuchDemoException if a demo with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Demo remove(Serializable primaryKey)
        throws NoSuchDemoException, SystemException {
        Session session = null;

        try {
            session = openSession();

            Demo demo = (Demo) session.get(DemoImpl.class, primaryKey);

            if (demo == null) {
                if (_log.isWarnEnabled()) {
                    _log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
                }

                throw new NoSuchDemoException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
                    primaryKey);
            }

            return remove(demo);
        } catch (NoSuchDemoException nsee) {
            throw nsee;
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }
    }

    @Override
    protected Demo removeImpl(Demo demo) throws SystemException {
        demo = toUnwrappedModel(demo);

        Session session = null;

        try {
            session = openSession();

            if (!session.contains(demo)) {
                demo = (Demo) session.get(DemoImpl.class,
                        demo.getPrimaryKeyObj());
            }

            if (demo != null) {
                session.delete(demo);
            }
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }

        if (demo != null) {
            clearCache(demo);
        }

        return demo;
    }

    @Override
    public Demo updateImpl(de.doubleslash.model.Demo demo)
        throws SystemException {
        demo = toUnwrappedModel(demo);

        boolean isNew = demo.isNew();

        Session session = null;

        try {
            session = openSession();

            if (demo.isNew()) {
                session.save(demo);

                demo.setNew(false);
            } else {
                session.merge(demo);
            }
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }

        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);

        if (isNew || !DemoModelImpl.COLUMN_BITMASK_ENABLED) {
            FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
        }

        EntityCacheUtil.putResult(DemoModelImpl.ENTITY_CACHE_ENABLED,
            DemoImpl.class, demo.getPrimaryKey(), demo);

        clearUniqueFindersCache(demo);
        cacheUniqueFindersCache(demo);

        return demo;
    }

    protected Demo toUnwrappedModel(Demo demo) {
        if (demo instanceof DemoImpl) {
            return demo;
        }

        DemoImpl demoImpl = new DemoImpl();

        demoImpl.setNew(demo.isNew());
        demoImpl.setPrimaryKey(demo.getPrimaryKey());

        demoImpl.setDemoId(demo.getDemoId());
        demoImpl.setCreatorGroupId(demo.getCreatorGroupId());
        demoImpl.setCreatorCompanyId(demo.getCreatorCompanyId());
        demoImpl.setCreatorUserId(demo.getCreatorUserId());
        demoImpl.setCreatorUserName(demo.getCreatorUserName());
        demoImpl.setCreateDate(demo.getCreateDate());
        demoImpl.setModifiedDate(demo.getModifiedDate());
        demoImpl.setText(demo.getText());

        return demoImpl;
    }

    /**
     * Returns the demo with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
     *
     * @param primaryKey the primary key of the demo
     * @return the demo
     * @throws de.doubleslash.NoSuchDemoException if a demo with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Demo findByPrimaryKey(Serializable primaryKey)
        throws NoSuchDemoException, SystemException {
        Demo demo = fetchByPrimaryKey(primaryKey);

        if (demo == null) {
            if (_log.isWarnEnabled()) {
                _log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
            }

            throw new NoSuchDemoException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
                primaryKey);
        }

        return demo;
    }

    /**
     * Returns the demo with the primary key or throws a {@link de.doubleslash.NoSuchDemoException} if it could not be found.
     *
     * @param demoId the primary key of the demo
     * @return the demo
     * @throws de.doubleslash.NoSuchDemoException if a demo with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Demo findByPrimaryKey(long demoId)
        throws NoSuchDemoException, SystemException {
        return findByPrimaryKey((Serializable) demoId);
    }

    /**
     * Returns the demo with the primary key or returns <code>null</code> if it could not be found.
     *
     * @param primaryKey the primary key of the demo
     * @return the demo, or <code>null</code> if a demo with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Demo fetchByPrimaryKey(Serializable primaryKey)
        throws SystemException {
        Demo demo = (Demo) EntityCacheUtil.getResult(DemoModelImpl.ENTITY_CACHE_ENABLED,
                DemoImpl.class, primaryKey);

        if (demo == _nullDemo) {
            return null;
        }

        if (demo == null) {
            Session session = null;

            try {
                session = openSession();

                demo = (Demo) session.get(DemoImpl.class, primaryKey);

                if (demo != null) {
                    cacheResult(demo);
                } else {
                    EntityCacheUtil.putResult(DemoModelImpl.ENTITY_CACHE_ENABLED,
                        DemoImpl.class, primaryKey, _nullDemo);
                }
            } catch (Exception e) {
                EntityCacheUtil.removeResult(DemoModelImpl.ENTITY_CACHE_ENABLED,
                    DemoImpl.class, primaryKey);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return demo;
    }

    /**
     * Returns the demo with the primary key or returns <code>null</code> if it could not be found.
     *
     * @param demoId the primary key of the demo
     * @return the demo, or <code>null</code> if a demo with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public Demo fetchByPrimaryKey(long demoId) throws SystemException {
        return fetchByPrimaryKey((Serializable) demoId);
    }

    /**
     * Returns all the demos.
     *
     * @return the demos
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Demo> findAll() throws SystemException {
        return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
    }

    /**
     * Returns a range of all the demos.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link de.doubleslash.model.impl.DemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param start the lower bound of the range of demos
     * @param end the upper bound of the range of demos (not inclusive)
     * @return the range of demos
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Demo> findAll(int start, int end) throws SystemException {
        return findAll(start, end, null);
    }

    /**
     * Returns an ordered range of all the demos.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link de.doubleslash.model.impl.DemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param start the lower bound of the range of demos
     * @param end the upper bound of the range of demos (not inclusive)
     * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
     * @return the ordered range of demos
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<Demo> findAll(int start, int end,
        OrderByComparator orderByComparator) throws SystemException {
        boolean pagination = true;
        FinderPath finderPath = null;
        Object[] finderArgs = null;

        if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
                (orderByComparator == null)) {
            pagination = false;
            finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL;
            finderArgs = FINDER_ARGS_EMPTY;
        } else {
            finderPath = FINDER_PATH_WITH_PAGINATION_FIND_ALL;
            finderArgs = new Object[] { start, end, orderByComparator };
        }

        List<Demo> list = (List<Demo>) FinderCacheUtil.getResult(finderPath,
                finderArgs, this);

        if (list == null) {
            StringBundler query = null;
            String sql = null;

            if (orderByComparator != null) {
                query = new StringBundler(2 +
                        (orderByComparator.getOrderByFields().length * 3));

                query.append(_SQL_SELECT_DEMO);

                appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
                    orderByComparator);

                sql = query.toString();
            } else {
                sql = _SQL_SELECT_DEMO;

                if (pagination) {
                    sql = sql.concat(DemoModelImpl.ORDER_BY_JPQL);
                }
            }

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                if (!pagination) {
                    list = (List<Demo>) QueryUtil.list(q, getDialect(), start,
                            end, false);

                    Collections.sort(list);

                    list = new UnmodifiableList<Demo>(list);
                } else {
                    list = (List<Demo>) QueryUtil.list(q, getDialect(), start,
                            end);
                }

                cacheResult(list);

                FinderCacheUtil.putResult(finderPath, finderArgs, list);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return list;
    }

    /**
     * Removes all the demos from the database.
     *
     * @throws SystemException if a system exception occurred
     */
    @Override
    public void removeAll() throws SystemException {
        for (Demo demo : findAll()) {
            remove(demo);
        }
    }

    /**
     * Returns the number of demos.
     *
     * @return the number of demos
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countAll() throws SystemException {
        Long count = (Long) FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
                FINDER_ARGS_EMPTY, this);

        if (count == null) {
            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(_SQL_COUNT_DEMO);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL,
                    FINDER_ARGS_EMPTY, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_ALL,
                    FINDER_ARGS_EMPTY);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    @Override
    protected Set<String> getBadColumnNames() {
        return _badColumnNames;
    }

    /**
     * Initializes the demo persistence.
     */
    public void afterPropertiesSet() {
        String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
                    com.liferay.util.service.ServiceProps.get(
                        "value.object.listener.de.doubleslash.model.Demo")));

        if (listenerClassNames.length > 0) {
            try {
                List<ModelListener<Demo>> listenersList = new ArrayList<ModelListener<Demo>>();

                for (String listenerClassName : listenerClassNames) {
                    listenersList.add((ModelListener<Demo>) InstanceFactory.newInstance(
                            getClassLoader(), listenerClassName));
                }

                listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
            } catch (Exception e) {
                _log.error(e);
            }
        }
    }

    public void destroy() {
        EntityCacheUtil.removeCache(DemoImpl.class.getName());
        FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
        FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
    }
}
