package de.doubleslash.service.persistence;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.ReferenceRegistry;
import com.liferay.portal.service.ServiceContext;

import de.doubleslash.model.Demo;

import java.util.List;

/**
 * The persistence utility for the demo service. This utility wraps {@link DemoPersistenceImpl} and provides direct access to the database for CRUD operations. This utility should only be used by the service layer, as it must operate within a transaction. Never access this utility in a JSP, controller, model, or other front-end class.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see DemoPersistence
 * @see DemoPersistenceImpl
 * @generated
 */
public class DemoUtil {
    private static DemoPersistence _persistence;

    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify this class directly. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
     */

    /**
     * @see com.liferay.portal.service.persistence.BasePersistence#clearCache()
     */
    public static void clearCache() {
        getPersistence().clearCache();
    }

    /**
     * @see com.liferay.portal.service.persistence.BasePersistence#clearCache(com.liferay.portal.model.BaseModel)
     */
    public static void clearCache(Demo demo) {
        getPersistence().clearCache(demo);
    }

    /**
     * @see com.liferay.portal.service.persistence.BasePersistence#countWithDynamicQuery(DynamicQuery)
     */
    public static long countWithDynamicQuery(DynamicQuery dynamicQuery)
        throws SystemException {
        return getPersistence().countWithDynamicQuery(dynamicQuery);
    }

    /**
     * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery)
     */
    public static List<Demo> findWithDynamicQuery(DynamicQuery dynamicQuery)
        throws SystemException {
        return getPersistence().findWithDynamicQuery(dynamicQuery);
    }

    /**
     * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int)
     */
    public static List<Demo> findWithDynamicQuery(DynamicQuery dynamicQuery,
        int start, int end) throws SystemException {
        return getPersistence().findWithDynamicQuery(dynamicQuery, start, end);
    }

    /**
     * @see com.liferay.portal.service.persistence.BasePersistence#findWithDynamicQuery(DynamicQuery, int, int, OrderByComparator)
     */
    public static List<Demo> findWithDynamicQuery(DynamicQuery dynamicQuery,
        int start, int end, OrderByComparator orderByComparator)
        throws SystemException {
        return getPersistence()
                   .findWithDynamicQuery(dynamicQuery, start, end,
            orderByComparator);
    }

    /**
     * @see com.liferay.portal.service.persistence.BasePersistence#update(com.liferay.portal.model.BaseModel)
     */
    public static Demo update(Demo demo) throws SystemException {
        return getPersistence().update(demo);
    }

    /**
     * @see com.liferay.portal.service.persistence.BasePersistence#update(com.liferay.portal.model.BaseModel, ServiceContext)
     */
    public static Demo update(Demo demo, ServiceContext serviceContext)
        throws SystemException {
        return getPersistence().update(demo, serviceContext);
    }

    /**
    * Returns the demo where demoId = &#63; or throws a {@link de.doubleslash.NoSuchDemoException} if it could not be found.
    *
    * @param demoId the demo ID
    * @return the matching demo
    * @throws de.doubleslash.NoSuchDemoException if a matching demo could not be found
    * @throws SystemException if a system exception occurred
    */
    public static de.doubleslash.model.Demo findBydemoId(long demoId)
        throws com.liferay.portal.kernel.exception.SystemException,
            de.doubleslash.NoSuchDemoException {
        return getPersistence().findBydemoId(demoId);
    }

    /**
    * Returns the demo where demoId = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
    *
    * @param demoId the demo ID
    * @return the matching demo, or <code>null</code> if a matching demo could not be found
    * @throws SystemException if a system exception occurred
    */
    public static de.doubleslash.model.Demo fetchBydemoId(long demoId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getPersistence().fetchBydemoId(demoId);
    }

    /**
    * Returns the demo where demoId = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
    *
    * @param demoId the demo ID
    * @param retrieveFromCache whether to use the finder cache
    * @return the matching demo, or <code>null</code> if a matching demo could not be found
    * @throws SystemException if a system exception occurred
    */
    public static de.doubleslash.model.Demo fetchBydemoId(long demoId,
        boolean retrieveFromCache)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getPersistence().fetchBydemoId(demoId, retrieveFromCache);
    }

    /**
    * Removes the demo where demoId = &#63; from the database.
    *
    * @param demoId the demo ID
    * @return the demo that was removed
    * @throws SystemException if a system exception occurred
    */
    public static de.doubleslash.model.Demo removeBydemoId(long demoId)
        throws com.liferay.portal.kernel.exception.SystemException,
            de.doubleslash.NoSuchDemoException {
        return getPersistence().removeBydemoId(demoId);
    }

    /**
    * Returns the number of demos where demoId = &#63;.
    *
    * @param demoId the demo ID
    * @return the number of matching demos
    * @throws SystemException if a system exception occurred
    */
    public static int countBydemoId(long demoId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getPersistence().countBydemoId(demoId);
    }

    /**
    * Caches the demo in the entity cache if it is enabled.
    *
    * @param demo the demo
    */
    public static void cacheResult(de.doubleslash.model.Demo demo) {
        getPersistence().cacheResult(demo);
    }

    /**
    * Caches the demos in the entity cache if it is enabled.
    *
    * @param demos the demos
    */
    public static void cacheResult(
        java.util.List<de.doubleslash.model.Demo> demos) {
        getPersistence().cacheResult(demos);
    }

    /**
    * Creates a new demo with the primary key. Does not add the demo to the database.
    *
    * @param demoId the primary key for the new demo
    * @return the new demo
    */
    public static de.doubleslash.model.Demo create(long demoId) {
        return getPersistence().create(demoId);
    }

    /**
    * Removes the demo with the primary key from the database. Also notifies the appropriate model listeners.
    *
    * @param demoId the primary key of the demo
    * @return the demo that was removed
    * @throws de.doubleslash.NoSuchDemoException if a demo with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public static de.doubleslash.model.Demo remove(long demoId)
        throws com.liferay.portal.kernel.exception.SystemException,
            de.doubleslash.NoSuchDemoException {
        return getPersistence().remove(demoId);
    }

    public static de.doubleslash.model.Demo updateImpl(
        de.doubleslash.model.Demo demo)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getPersistence().updateImpl(demo);
    }

    /**
    * Returns the demo with the primary key or throws a {@link de.doubleslash.NoSuchDemoException} if it could not be found.
    *
    * @param demoId the primary key of the demo
    * @return the demo
    * @throws de.doubleslash.NoSuchDemoException if a demo with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public static de.doubleslash.model.Demo findByPrimaryKey(long demoId)
        throws com.liferay.portal.kernel.exception.SystemException,
            de.doubleslash.NoSuchDemoException {
        return getPersistence().findByPrimaryKey(demoId);
    }

    /**
    * Returns the demo with the primary key or returns <code>null</code> if it could not be found.
    *
    * @param demoId the primary key of the demo
    * @return the demo, or <code>null</code> if a demo with the primary key could not be found
    * @throws SystemException if a system exception occurred
    */
    public static de.doubleslash.model.Demo fetchByPrimaryKey(long demoId)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getPersistence().fetchByPrimaryKey(demoId);
    }

    /**
    * Returns all the demos.
    *
    * @return the demos
    * @throws SystemException if a system exception occurred
    */
    public static java.util.List<de.doubleslash.model.Demo> findAll()
        throws com.liferay.portal.kernel.exception.SystemException {
        return getPersistence().findAll();
    }

    /**
    * Returns a range of all the demos.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link de.doubleslash.model.impl.DemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of demos
    * @param end the upper bound of the range of demos (not inclusive)
    * @return the range of demos
    * @throws SystemException if a system exception occurred
    */
    public static java.util.List<de.doubleslash.model.Demo> findAll(int start,
        int end) throws com.liferay.portal.kernel.exception.SystemException {
        return getPersistence().findAll(start, end);
    }

    /**
    * Returns an ordered range of all the demos.
    *
    * <p>
    * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link de.doubleslash.model.impl.DemoModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
    * </p>
    *
    * @param start the lower bound of the range of demos
    * @param end the upper bound of the range of demos (not inclusive)
    * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
    * @return the ordered range of demos
    * @throws SystemException if a system exception occurred
    */
    public static java.util.List<de.doubleslash.model.Demo> findAll(int start,
        int end,
        com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
        throws com.liferay.portal.kernel.exception.SystemException {
        return getPersistence().findAll(start, end, orderByComparator);
    }

    /**
    * Removes all the demos from the database.
    *
    * @throws SystemException if a system exception occurred
    */
    public static void removeAll()
        throws com.liferay.portal.kernel.exception.SystemException {
        getPersistence().removeAll();
    }

    /**
    * Returns the number of demos.
    *
    * @return the number of demos
    * @throws SystemException if a system exception occurred
    */
    public static int countAll()
        throws com.liferay.portal.kernel.exception.SystemException {
        return getPersistence().countAll();
    }

    public static DemoPersistence getPersistence() {
        if (_persistence == null) {
            _persistence = (DemoPersistence) PortletBeanLocatorUtil.locate(de.doubleslash.service.ClpSerializer.getServletContextName(),
                    DemoPersistence.class.getName());

            ReferenceRegistry.registerReference(DemoUtil.class, "_persistence");
        }

        return _persistence;
    }

    /**
     * @deprecated As of 6.2.0
     */
    public void setPersistence(DemoPersistence persistence) {
    }
}
